''*************************************''
''*    VassalDarlington.spin  v1.0    *''
''*  (C) 2008 Branmuffin Industries   *''
''*************************************''
CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  
    LeftPack  = 0
    RightPack = 1
  
VAR

    byte PackAFirstRelaypin
    byte PackBFirstRelaypin
    
PUB Init( _Darlingtonpin )   'initializes four sequential pins for pack A and the next four pins for pack B. 


   'store my startpin as a variable
   PackAFirstRelaypin := _Darlingtonpin      
   PackBFirstRelaypin := _Darlingtonpin + 4
   
   ' set my four I/O pins low (do not engage darlington transistor)
   ChargeOff( LeftPack )
   ChargeOff( RightPack )        
 
   ' set my four I/O pins to outputs
   dira[PackAFirstRelaypin..PackAFirstRelaypin+7]~~  
   'dira[8..15]~~
   
PUB Charge ( _Pack, _thisBatt )  'stops charging all four cells, turns on charging for specified cell (1-4)

   ChargeOff ( _Pack )  'turns charging off

   if _Pack == LeftPack ' Pins set high will trigger charging.          
           
           outa[PackAFirstRelaypin+_thisBatt-1]~~  ' Set the correct battery pin high    
   else
           outa[PackBFirstRelaypin+_thisBatt-1]~~  ' Set the correct battery pin high  

  
PUB ChargeOff ( _Pack )     'stops charging all four cells

   if _Pack == LeftPack ' Pins set high will trigger charging. Set all pins low to turn charging off.           
           outa[PackAFirstRelaypin..PackAFirstRelaypin+3]~   'sets all four pins low
   else
           outa[PackBFirstRelaypin..PackBFirstRelaypin+3]~   'sets all four pins low      
                                  ' add a pause after chargeoff to make sure all coils collapse
   waitcnt( 300_000_000 + cnt)     'Wait for coil collapse   

PUB AllChargingOff

   outa[PackAFirstRelaypin..PackAFirstRelaypin+3]~   'sets all four pins low
   outa[PackBFirstRelaypin..PackBFirstRelaypin+3]~   'sets all four pins low
                                  ' add a pause after chargeoff to make sure all coils collapse
   waitcnt( 300_000_000 + cnt)     'Wait for coil collapse

PUB Select ( _Pack, _thisBatt )  'stops charging all four cells, turns on charging for specified cell (1-4)

   ChargeOff ( _Pack )  'turns charging off

   if _Pack == LeftPack ' Pins set high will trigger charging.          
           
           outa[PackAFirstRelaypin+4-_thisBatt]~~  ' Set the correct battery pin high    
   else
           outa[PackBFirstRelaypin+_thisBatt-1]~~  ' Set the correct battery pin high  

       